
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "kernsysteme",
    "makrodefinitionen",
    "usv",
    "rechner"
})
public class Global implements Serializable
{

    @JsonProperty("kernsysteme")
    private List<KernSystem> kernsysteme = new ArrayList<KernSystem>();
    @JsonProperty("makrodefinitionen")
    private List<MakroDefinition> makrodefinitionen = new ArrayList<MakroDefinition>();
    @JsonProperty("usv")
    private Usv usv;
    @JsonProperty("rechner")
    private List<Rechner> rechner = new ArrayList<Rechner>();
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = -6595950771608361110L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public Global() {
    }

    /**
     * 
     * @param rechner
     * @param makrodefinitionen
     * @param usv
     * @param kernsysteme
     */
    public Global(List<KernSystem> kernsysteme, List<MakroDefinition> makrodefinitionen, Usv usv, List<Rechner> rechner) {
        super();
        this.kernsysteme = kernsysteme;
        this.makrodefinitionen = makrodefinitionen;
        this.usv = usv;
        this.rechner = rechner;
    }

    @JsonProperty("kernsysteme")
    public List<KernSystem> getKernsysteme() {
        return kernsysteme;
    }

    @JsonProperty("kernsysteme")
    public void setKernsysteme(List<KernSystem> kernsysteme) {
        this.kernsysteme = kernsysteme;
    }

    public Global withKernsysteme(List<KernSystem> kernsysteme) {
        this.kernsysteme = kernsysteme;
        return this;
    }

    @JsonProperty("makrodefinitionen")
    public List<MakroDefinition> getMakrodefinitionen() {
        return makrodefinitionen;
    }

    @JsonProperty("makrodefinitionen")
    public void setMakrodefinitionen(List<MakroDefinition> makrodefinitionen) {
        this.makrodefinitionen = makrodefinitionen;
    }

    public Global withMakrodefinitionen(List<MakroDefinition> makrodefinitionen) {
        this.makrodefinitionen = makrodefinitionen;
        return this;
    }

    @JsonProperty("usv")
    public Usv getUsv() {
        return usv;
    }

    @JsonProperty("usv")
    public void setUsv(Usv usv) {
        this.usv = usv;
    }

    public Global withUsv(Usv usv) {
        this.usv = usv;
        return this;
    }

    @JsonProperty("rechner")
    public List<Rechner> getRechner() {
        return rechner;
    }

    @JsonProperty("rechner")
    public void setRechner(List<Rechner> rechner) {
        this.rechner = rechner;
    }

    public Global withRechner(List<Rechner> rechner) {
        this.rechner = rechner;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public Global withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(Global.class.getName()).append('@').append(Integer.toHexString(System.identityHashCode(this))).append('[');
        sb.append("kernsysteme");
        sb.append('=');
        sb.append(((this.kernsysteme == null)?"<null>":this.kernsysteme));
        sb.append(',');
        sb.append("makrodefinitionen");
        sb.append('=');
        sb.append(((this.makrodefinitionen == null)?"<null>":this.makrodefinitionen));
        sb.append(',');
        sb.append("usv");
        sb.append('=');
        sb.append(((this.usv == null)?"<null>":this.usv));
        sb.append(',');
        sb.append("rechner");
        sb.append('=');
        sb.append(((this.rechner == null)?"<null>":this.rechner));
        sb.append(',');
        sb.append("additionalProperties");
        sb.append('=');
        sb.append(((this.additionalProperties == null)?"<null>":this.additionalProperties));
        sb.append(',');
        if (sb.charAt((sb.length()- 1)) == ',') {
            sb.setCharAt((sb.length()- 1), ']');
        } else {
            sb.append(']');
        }
        return sb.toString();
    }

    @Override
    public int hashCode() {
        int result = 1;
        result = ((result* 31)+((this.rechner == null)? 0 :this.rechner.hashCode()));
        result = ((result* 31)+((this.usv == null)? 0 :this.usv.hashCode()));
        result = ((result* 31)+((this.makrodefinitionen == null)? 0 :this.makrodefinitionen.hashCode()));
        result = ((result* 31)+((this.additionalProperties == null)? 0 :this.additionalProperties.hashCode()));
        result = ((result* 31)+((this.kernsysteme == null)? 0 :this.kernsysteme.hashCode()));
        return result;
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof Global) == false) {
            return false;
        }
        Global rhs = ((Global) other);
        return ((((((this.rechner == rhs.rechner)||((this.rechner!= null)&&this.rechner.equals(rhs.rechner)))&&((this.usv == rhs.usv)||((this.usv!= null)&&this.usv.equals(rhs.usv))))&&((this.makrodefinitionen == rhs.makrodefinitionen)||((this.makrodefinitionen!= null)&&this.makrodefinitionen.equals(rhs.makrodefinitionen))))&&((this.additionalProperties == rhs.additionalProperties)||((this.additionalProperties!= null)&&this.additionalProperties.equals(rhs.additionalProperties))))&&((this.kernsysteme == rhs.kernsysteme)||((this.kernsysteme!= null)&&this.kernsysteme.equals(rhs.kernsysteme))));
    }

}
